DOSSEG
.MODEL small
.STACK 100h

.DATA
Maximum_String_Length EQU       80
buffer db Maximum_String_Length DUP(?)
message db 'Type a line:',0dh,0ah,0dh,0ah,'$'
buffer_A        db 6 dup(' ')   ;       this is for wrint
table   db      'AAABBB',00h,'BBCCCC',00h,'DOGbbb',00h,'Horseb',00h,'Zebrab',00h
top     dw      04h             ;       list count - 1
bottom  dw      00h
middle  dw      00h
position        db      'Found at position ','$'
notfoundmes     db      'Your selection not found.',0dh,0ah,'$'

.CODE

Main proc
Start:
        mov     ax,@data        ;       set up data seg
        mov     ds,ax           ;       move address to ds
        mov     es,ax           ;       initialize ES
        mov     cx,0            ;       clear counter

;--------------------------------------------------------------------------
        mov     ah,09h          ;       print input message for user
        mov     dx,OFFSET message
        int 21h

        mov     ah,3fh          ;       DOS read from handle function
        mov     bx,0            ;       standard input handle
        mov     cx,Maximum_String_Length ;      read up to max. no. of chrs.
        mov     dx,OFFSET buffer ;      store the string here
        int     21h
        and     ax,ax           ;       were any chrs. read?
        mov     cx,ax           ;       put string length in cx for counter

        mov     ah,40h          ;       DOS write from handle function
        mov     bx,1            ;       standard output handle
        mov     dx,OFFSET buffer ;      print this string
        int     21h

;-----------------------------------------------------------------------------
While:  mov     ax,top          ;       While
        mov     bx,bottom       ;       top>=bottom
        cmp     ax,bx           ;
        jl      NotFound        ;       if not, string not found
        add     ax,bx           ;       add bottom to top
        shr     ax,1            ;       divide the result by 2
        mov     middle,ax       ;       this is the middle

        mov     si,offset buffer;       get ready to compare these strings
        mov     di,offset table
        mov     bx,7            ;       7 is the record length
        mul     bx              ;       multiply record number by 7 for record offset
        add     di,ax           ;       add the record offset
        call strcomp            ;       go ahead and compare the strings
        je      string1_same    ;       Successful search
        ja      string1_less    ;       Look in upper half of list
        jb      string1_more    ;       Look in lower half of list
        jmp     Done


string1_less:                   ;       Look in upper half of list
        push    ax              ;       This is the assembly version
        mov     ax,middle       ;       of bottom = middle + 1
        add     ax,1
        mov     bottom,ax
        pop     ax
        jmp     While

string1_more:                   ;       Look in lower half of list
        push    ax              ;       This is the assembly version 
        mov     ax,middle       ;       of top = middle - 1
        sub     ax,1
        mov     top,ax
        pop     ax
        jmp     While

string1_same:
        mov     ah,09h
        mov     dx,OFFSET position   ;      Print the Position message
        int 21h
        mov     ax,middle            ;      Print where the word was found
        call    wrint
        call    newline
        jmp     Done

NotFound:
        mov     ah,09h                  ;  Print the Not Found message
        mov     dx,OFFSET notfoundmes
        int 21h


;--------------------------------------------------------------------------
Done:   mov     ah,4ch          ;       nice DOS termination
        int 21h                 ;       call DOS
Main endp



;----------------------------------------------------------------------------
newline proc                    ;       Display a CR/LF
        push    ax              ;       save register
        push    bx              ;
        push    cx              ;
        push    dx              ;
        mov     dl,0Ah          ;       get ready to do a LF
        mov     ah,02h          ;       tell DOS we want to display
        int     21h             ;       call DOS
        mov     dl,0Dh          ;       get ready to do a CR
        mov     ah,02h          ;
        int     21h             ;       call DOS
        pop     dx              ;       restore registers
        pop     cx              ;
        pop     bx              ;
        pop     ax              ;
        ret
newline endp

wrint proc
        push    ax              ;       save registers!!
        push    bx
        push    cx
        push    dx
        push    di
        mov     cx,0            ;       set digit counter to 0
        mov     di, offset buffer_A + 6 ;       point past end of buffer

        ;       divide AX, convert remainder to ASCII

        mov     bx,10           ;       divisor=10
A1:     mov     dx,0            ;       clear dividend to 0
        div     bx              ;       divide AX by 10
        or      dl,30h          ;       convert remainder to ASCII
        dec     di              ;       reverse through the buffer
        mov     [di],dl         ;       store ASCII digit
        inc     cx              ;       increment counter
        or      ax,ax           ;       quotient=0?
        jnz     A1              ;       no; divide again

        ;       display the buffer, using cx as a counter

A2:     mov     ah,2            ;       function: display character
        mov     dl,[di]         ;       get digit from buffer
        int     21h             ;       call DOS
        inc     di              ;       point to next digit
        loop    A2

        pop     di              ;       restore registers
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret

wrint endp

strlen          proc            ;       ES:DI points to the string
        push    cx
        push    di              ;       save pointer to string
        mov     cx,0FFFFh       ;       set CX to maximum word value
        mov     al,0            ;       scan for zero terminator
        cld                     ;       direction = up
        repnz   scasb           ;       compare AL to ES:[DI]
        dec     di              ;       back up one position
        mov     ax,di           ;       get ending pointer
        pop     di              ;       retrieve starting pointer
        sub     ax,di           ;       subtract start from end
        pop     cx              ;
        ret                     ;       AX = string length
strlen endp

strcomp proc
        push    ax
        push    cx
        push    si
        push    di
        call    strlen          ;       get length of destination
        mov     cx,ax           ;       store in CX
        cld                     ;       clear direction to up
        rep     cmpsb
        pop     di
        pop     si
        pop     cx
        pop     ax
        ret
strcomp endp
END     Start




